#!/usr/bin/perl
use strict;
use warnings;
use Test::More;

use lib 't/lib';
{

    package FooWithXoxo;

    use Moo qw(has);

    has xoxo => ( is => 'ro' );

    use MooX::Role::Parameterized::With;

    with BarWithRequires =>
      { attr => 'baz', method => 'run', requires => 'xoxo' };

    has foo => ( is => 'ro' );
}

my $foo = FooWithXoxo->new( foo => 1, bar => 2, baz => 3 );

isa_ok $foo, 'FooWithXoxo', 'foo';
ok $foo->DOES('BarWithRequires'), 'foo should does Bar';
is $foo->foo, 1, 'should has foo';
is $foo->bar, 2, 'should has bar ( from Role )';
is $foo->baz, 3, 'should has baz ( from parameterized Role)';
ok $foo->can('run'), 'should can run';
is $foo->run, 1024, 'should call run';

done_testing;
